﻿using UnityEngine;
using System.Collections;
using Sirenix.OdinInspector;
using UnityEngine.SceneManagement;
using System.Linq;
using System.Collections.Generic;
using UnityEditor.SceneManagement;
using Sirenix.OdinInspector.Editor;

[CreateAssetMenu(fileName = "ScriptableExecuter", menuName = "Example/ScriptableExecuter", order = 0)]
public class ScriptableExecuter : SerializedScriptableObject
{
    [Required] public Mob someMobPrefab;

    [Button(ButtonSizes.Large), GUIColor(.3f, 1f, .3f)]
    public void LetsGo()
    {
        var gameObject = SceneManager.GetActiveScene().GetRootGameObjects()
            .First(x => x.name == "Quantum GameObject");

        var component = gameObject.GetComponent<QuantumComponent>();
        var list = component.list1;

        list.Clear();

        for(int i = 0; i < 3; i++)
        {
            list.Add(new List<QuantumComponent.Data>());
            for(int j = 0; j < 3; j++)
            {
                list[i].Add(new QuantumComponent.Data
                {
                    mob = someMobPrefab,
                    mobLevel = 10,
                    delay = 5.5f,
                    quantity = 3,
                    mobsPerSecond = 2f
                });
            }
        }

        EditorSceneManager.MarkSceneDirty(EditorSceneManager.GetActiveScene());
        OdinPrefabUtility.UpdatePrefabInstancePropertyModifications(component, true);
    }
}
